//+------------------------------------------------------------------+
//|                                             AllAverages_v3.1.mq4 |
//|                             Copyright  2007-13, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+

// MA_Method=13: Median     - Moving Median

// List of Prices:
// Price    = 0 - Close  

 
#property copyright "Copyright  2007-13, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  Silver
#property indicator_width1  2  
#property indicator_color2  DeepSkyBlue
#property indicator_width2  2  
#property indicator_color3  Tomato
#property indicator_width3  2  


//---- 
extern int     TimeFrame    =  0;
extern int     Price        =  0;
extern int     MA_Period    = 14;
extern int     MA_Shift     =  0;
extern int     MA_Method    =  13;
extern int     Color_Mode   =  0;


extern string  PriceMode    = "";
extern string  _0           = "Close";

extern string  MAMode       = "";
extern string  __13         = "Median";


double MA[];
double Up[];
double Dn[];
double aPrice[];
//----
double tmp[][2];
int    draw_begin, arraysize; 
string IndicatorName, TF, short_name;
int    sUp = 0, sDn =0; 
datetime prevtime, prevhatime;  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- 
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   
   if(TimeFrame == 0 || TimeFrame < Period()) TimeFrame = Period();

//----
   IndicatorBuffers(4); 
   
   SetIndexBuffer(0,    MA); SetIndexStyle(0,DRAW_LINE); SetIndexShift(0,MA_Shift*TimeFrame/Period());
   SetIndexBuffer(1,    Up); SetIndexStyle(1,DRAW_LINE); SetIndexShift(1,MA_Shift*TimeFrame/Period());
   SetIndexBuffer(2,    Dn); SetIndexStyle(2,DRAW_LINE); SetIndexShift(2,MA_Shift*TimeFrame/Period());
   SetIndexBuffer(3,aPrice);
   
   draw_begin=2*MathCeil(0.5*(MA_Period+1))*TimeFrame/Period();
   SetIndexDrawBegin(0,draw_begin);   
   SetIndexDrawBegin(1,draw_begin);
   SetIndexDrawBegin(2,draw_begin);

//---- 
   
   
   switch(MA_Method)
   {
   
   case 13: short_name="Median(";  break;
   
   }
   
   switch(TimeFrame)
   {
   case 1     : TF = "M1" ; break;
   case 5     : TF = "M5" ; break;
   case 15    : TF = "M15"; break;
   case 30    : TF = "M30"; break;
   case 60    : TF = "H1" ; break;
   case 240   : TF = "H4" ; break;
   case 1440  : TF = "D1" ; break;
   case 10080 : TF = "W1" ; break;
   case 43200 : TF = "MN1"; break;
   default    : TF = "Current";
   } 
   
   IndicatorName = WindowExpertName(); 
   
   IndicatorShortName(short_name+MA_Period+")"+" "+TF);
   
   SetIndexLabel(1,short_name+MA_Period+")"+" "+TF+" UpTrend");
   SetIndexLabel(2,short_name+MA_Period+")"+" "+TF+" DnTrend");
   SetIndexLabel(0,short_name+MA_Period+")"+" "+TF);
      
//----   
   ArrayResize(tmp,arraysize);
      
   return(0);
}
//+------------------------------------------------------------------+
//| AllAverages_v3.1                                                 |
//+------------------------------------------------------------------+
int start()
{
   int limit, y, i, shift, cnt_bars = IndicatorCounted(); 
   
   if(cnt_bars > 0)  limit = Bars - cnt_bars - 1;
   if(cnt_bars < 0)  return(0);    
   if(cnt_bars < 1)
   {
   limit = Bars - 1;
   
      for(i=Bars-1;i>0;i--) 
      { 
      MA[i] = EMPTY_VALUE; 
      Up[i] = EMPTY_VALUE;
      Dn[i] = EMPTY_VALUE;
      }
   }
   
   
//---- 
   if(TimeFrame != Period())
	{
   limit = MathMax(limit,TimeFrame/Period()+1);   
      
      for(shift = 0;shift < limit;shift++) 
      {	
      y = iBarShift(NULL,TimeFrame,Time[shift]);
      
      MA[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,Price,MA_Period,MA_Shift,MA_Method,Color_Mode,0,y);    
         
         if(Color_Mode > 0)
         {
         Up[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,Price,MA_Period,MA_Shift,MA_Method,Color_Mode,1,y);    
         Dn[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,Price,MA_Period,MA_Shift,MA_Method,Color_Mode,2,y);    
         }
      }  
	
	return(0);
	}
   else
   {
      for(shift=limit;shift>=0;shift--) 
      {
         if(arraysize > 1 && prevtime != Time[shift])
         {
         for(i=0;i<arraysize;i++) tmp[i][1] = tmp[i][0];
         prevtime = Time[shift];
         }

         
         if(Price <= 0) aPrice[shift] = iMA(NULL,0,1,0,0,Price,shift);   
         
         switch(MA_Method)
         {
         
         case 13: MA[shift] = Median(aPrice,MA_Period,shift); break;
         
         }
                  
         if(Color_Mode == 1)
         {
         Up[shift] = EMPTY_VALUE; 
         Dn[shift] = EMPTY_VALUE;
            
            if(MA[shift] > MA[shift+1]) Up[shift] = MA[shift]; 
            else
            if(MA[shift] < MA[shift+1]) Dn[shift] = MA[shift];
                    
      
         }
      }
   }
   
//---- 
   return(0);
}

// MA_Method=13: Median - Moving Median
double Median(double price[],int per,int bar)
{
   double array[];
   ArrayResize(array,per);
   
   for(int i = 0; i < per;i++) array[i] = price[bar+i];
   ArraySort(array);
   
   int num = MathRound((per-1)/2); 
   if(MathMod(per,2) > 0) double median = array[num]; else median = 0.5*(array[num]+array[num+1]);
    
   return(median); 
}

//+++++++++++++++++++++++++++++++++++++++++++++++++



